// my.cpp : Defines the entry point for the console application.
//
#include <iostream> 
#include <fstream> 
#include <iomanip>
#include <math.h>
//
using namespace std;
using std::ofstream;
using std::ifstream;
using std::cout; 
using std::cin;
using std::setw; 
using std::endl;
//
ofstream myofs; 
ifstream myifs; 
//
int main()
{  
myofs.open("myproto.txt");
myofs << setiosflags(ios::fixed) << setiosflags(ios::right) << setw(10);
myofs << " 123,   . 18  2008 ." << endl; 
myofs << "  03. " << endl << endl; 
{
  myofs << " 03-01.   for c   ." << endl;
  int m, n=0; 
  double d=0;
  for(m=1; m<124; m++)
  {
    d += 1.0/double(m);
    n++;
  }
  myofs << "  n=" << n;
  myofs << ",  " << n << "   =" << d << endl;
  myofs << "   m    m=" << m << endl << endl;
}
{
  myofs << " 03-02.   for c  ." << endl;
  int m, n=0; 
  double d=0;
  for(m=1; m<124; m+=2)
  {
    d += 1.0/double(m);
    n++;
  }
  myofs << "  n=" << n << ",  " << n << "    =" << d << endl;
  myofs << "   m    m=" << m << endl << endl;
}
{
  myofs << " 03-03.   for     break" << endl;
  int n=0; double d=0;
  for(int m=1; m<100000; m++)
  {
    d += 1.0/double(m);
    n++;
    if (d>10.0) break;
  }
  myofs << "  n=" << n << ",  " << n << "   =" << d << endl << endl;
}
{
  myofs << " 03-04.   for c   goto" << endl;
  int n=0; double d=0;
  for(int m=1; m<100000; m++)
  {
    d += 1.0/double(m);
    n++;
    if(d>10.0) goto next;
  }
  next: 
  myofs << "  n=" << n << ",  " << n << "    =" << d << endl << endl;
}
{
  myofs << " 03-05.  for   continue" << endl;
  int n=0; double d=0;
  for(int m=1; m<1000; m++)
  {
    if (m%2==1) continue;
    d += 1.0/double(m);
    n++;
  }
  myofs << "  n=" << n << ",  " << n << "    =" << d << endl << endl;
}
{
  myofs << " 03-06. !!!   for   " << endl;
  int m, n; double d;
  for(m=1, n=0, d=0.0; m<1000; m++)
  {
    if (m%2==1) continue;
    d += 1.0/double(m);
    n++;
  }
  myofs << "  n=" << n << ",  " << n << "    =" << d << endl << endl;
}
{
  myofs << " 03-07. !!!   for   " << endl;
  int n=7; double d=888;
  for(int m=1, n=0, d=0.0; m<1000; m++){
    if (m%2==1) continue;
    d += 1.0/double(m);
    n++;
  }
  myofs << "  n=" << n << ",  " << n << "    =" << d << endl << endl;
}
{
  myofs << " 03-08. !!!   for   " << endl;
  int n=0; double d=0.0;
  for(int m=1; m<1000; m++, n++, d+=1.0/double(m)){}
  myofs << "  n=" << n << ",  " << n << "   =" << d << endl << endl;
}
{
  myofs << " 03-09.   for   " << endl;
  double d=0.0; 
  int counter=0;
  for(double x=1.5; x<10.0; x+=1.0, d+=x, counter++);
  myofs << " =" << counter << ",  =" << d << endl << endl;
}
{
  myofs << " 03-10.  do-while" << endl;
  int n=0; 
  double d=0;
  do{n++; d+=1.0/double(n);}
  while(n<1000);
  myofs << "  n=" << n << ",  " << n << "   =" << d << endl << endl;
}
{
  myofs << " 03-11.  while" << endl;
  int n=0; 
  double d=0;
  while(n<1000){
    n++; 
    d+=1.0/double(n);
  }
  myofs << "  n=" << n << ",  " << n << "   =" << d << endl << endl;
}
{
  myofs << " 03-12.  while(true)" << endl;
  int n=0; double d=0;
  while(true)
  {
    n++; 
    d += 1.0/double(n);
    if(d>10.0)break;
  }
  myofs << "  n=" << n << ",  " << n << "   =" << d << endl << endl;
}
{
  myofs << " 03-13.   ." << endl;
  const int M=12, N=5; 
  int m, n;
  double a[M][N];
  for(m=0; m<M; m++)
    for(n=0; n<N; n++)
      a[m][n] = m*n;
    for(m=0; m<M; m++)
    {
      for(n=0; n<N; n++)
      {
        myofs << "  a[" << setw(2) << m << "," << setw(2) << n << "]=";
        myofs << setw(5) << setprecision(1) << a[m][n];
      }
      myofs << endl;
    }
  myofs << endl;
}
{
  myofs << " 03-14.  ." << endl;
  const int M=12, N=5; 
  int m, n;
  double a[M][N];
  for(m=0; m<M; m++)
    for(n=0; n<N; n++)
      a[m][n] = m*n;
    myofs << "    ";
  for(n=0; n<N; n++)
    myofs << setw(6) << n;
  myofs << endl;
  for(m=0; m<M; m++)
  {
    myofs << setw(3) << m << "  ";
    for(n=0; n<N; n++)
      myofs << setw(6) << setprecision(1) << a[m][n];
    myofs << endl;
  }
  myofs << endl;
}
{
  myofs << " 03-15.   " << endl;
  const int M=12, N=5; 
  double a[M][N];
  double ar1[M], ar2[M], ac1[N], ac2[N];
  int ir1[M], ir2[M], ic1[N], ic2[N];
  int m, n, m1, m2, n1, n2;
  double d1, d2, d3;
  for(m=0; m<M; m++)
    for(n=0; n<N; n++)
      a[m][n] = 10.0*((double(rand())/double(RAND_MAX))*2.0-1.0);
  for(m=0; m<M; m++)
  {
    d1=d2=a[m][0]; 
    n1=n2=0;
    for(n=1; n<N; n++)
    {
      d3=a[m][n];
      if(d3<d1){d1=d3; n1=n;}
      if(d3>d2){d2=d3; n2=n;}
    }
  ar1[m]=d1;
  ar2[m]=d2;
  ir1[m]=n1;
  ir2[m]=n2;
  }
  for(n=0; n<N; n++)
  {
    d1=d2=a[0][n]; 
    m1=m2=0;
    for(m=1; m<M; m++)
    {
      d3=a[m][n];
      if(d3<d1){d1=d3; m1=m;}
      if(d3>d2){d2=d3; m2=m;}
    }
    ac1[n]=d1;
    ac2[n]=d2;
    ic1[n]=m1;
    ic2[n]=m2;
  }
  myofs << "                   ";
  for(n=0; n<N; n++){myofs << " [" << setw(2) << ic2[n] << "," << n << "]";} myofs << endl;
  myofs << "                   ";
  for(n=0; n<N; n++){myofs << setw(7) << setprecision(3) << ac2[n];} myofs << endl;
  myofs << "                 ------------------------------------------------------------" << endl;
  for(m=0; m<M; m++){
    myofs << "a[" << setw(2) << m << "," << setw(1) << ir1[m] << "]=" << setw(7) << setprecision(3) << ar1[m] << " || ";
    for(n=0; n<N; n++){
      myofs << setw(7) << setprecision(3) << a[m][n];
    }
    myofs << " || a[" << setw(2) << m << "," << setw(1) << ir2[m] << "]=" << setw(7) << setprecision(3) << ar2[m] << endl;
  }
  myofs << "                 ------------------------------------------------------------" << endl;
  myofs << "                   ";
  for(n=0; n<N; n++){myofs << " [" << setw(2) << ic1[n] << "," << n << "]";} myofs << endl;
  myofs << "                   ";
  for(n=0; n<N; n++){myofs << setw(7) << setprecision(3) << ac1[n];} myofs << endl;
}
myofs.close();
return 0;
}

